Bug 234761 - yum shell 'config exclude' does not work
yum shell 'config exclude' does not work
Status: CLOSED CANTFIX
Product: Fedora
Classification: Fedora
Component: yum (Show other bugs)
6
All Linux
medium Severity medium
: ---
: ---
Assigned To: James Antill
: Reopened
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2007-04-01 12:53 EDT by Carl Roth
Modified: 2014-01-21 17:57 EST (History)
0 users

See Also:
Fixed In Version: 3.0.6
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2007-08-03 15:33:56 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
command output from 'yum shell' (4.02 KB, text/plain)
2007-04-01 12:53 EDT, Carl Roth
no flags Details
command output from 'yum shell' (8.50 KB, text/plain)
2007-04-25 17:02 EDT, Carl Roth
no flags Details

  None (edit)
Description Carl Roth 2007-04-01 12:53:23 EDT
Description of problem:

The 'config exclude' command in the yum shell does not behave the same as the
'--exclude' command-line option to yum.  It appears to be excluding too much of
the transaction set (usually all of it).  Attached is output from a shell
session to illustrate.

Version-Release number of selected component (if applicable):

yum-3.0.5-1.fc6
(this is the latest version that includes a fix for my other 'config exclude' bug)

How reproducible:


Steps to Reproduce:
1. run 'yum shell'
2. type 'upgrade'
3. type 'config exclude XXX'
4. type 'upgrade'

Actual results:

Too many (usually, all) packages are excluded.

Expected results:


Additional info:
Comment 1 Carl Roth 2007-04-01 12:53:23 EDT
Created attachment 151391 [details]
command output from 'yum shell'
Comment 2 Jeremy Katz 2007-04-25 14:05:28 EDT
This seems to work better with yum 3.0.6
Comment 3 Carl Roth 2007-04-25 17:02:51 EDT
Created attachment 153458 [details]
command output from 'yum shell'
Comment 4 Carl Roth 2007-04-25 17:04:57 EDT
How do you define "better" here?  I upgrade to the latest yum-3.0.6-1.fc6, and
the behavior is essentially the same.  See the attached command log (153458).
Comment 5 Seth Vidal 2007-04-25 17:54:19 EDT
I can't replicate this on 3.0.X from cvs and the changes from there to 3.0.6 are
pretty small.

is there anything else at play here? Are you sure you only have one version of
yum installed and nothing in your python lookup paths.
Comment 6 Carl Roth 2007-04-26 14:16:11 EDT
This was an interesting bug to track down.  I scrubbed my yum environment and
isolated the issue to the particular way I have my yum.conf and yum repositories
configured w.r.t the 'exclude' option.

* I set 'reposdir' in yum.conf to point to multiple directories of repo files. 
I do this so that I can maintain a directory of dynamic repository config files
(to support laptop roaming etc. and other userland edits)

  [main]
  ...
  reposdir=/etc/yum.repos.d, /srv/yum/repos.d
  ...

* I list the same YUM channel ('updates' in this case) in multiple repository
files spread across multiple directories.  for example:

  /etc/yum/fedora-updates.repo
  /srv/yum/repos.d/updates.repo

  Both files refer to the 'updates' channel; the second 'updates.repo' file
contains incremental configuration options ('enabled', 'exclude', 'proxy',
etc.).  Yum is supposed to scour each of the directories and overlay the
repository settings, and this works for the most part.

* I list the 'exclude' option in each copy of the 'updates' channel definition.
 My goal here was to specify an updated 'exclude' list in a repository config
file that's sourced later in the process, so that I could override any previous
settings.

To make a long story short, listing the 'exclude' setting multiple times seems
to mess with the yum shell.  If I use the same 'exclude' list, the 'config
exclude' shell command works:

  In /etc/yum.repos.d/fedora-updates.repo:
  [updates]
  ...
  exclude=kernel-* qemu-*
  ...

  In /srv/yum/repos.d/updates.repo:
  [updates]
  ...
  exclude=kernel-* qemu-*

If I try to override the 'exclude' setting, it doesn't work:

  In /etc/yum.repos.d/fedora-updates.repo:
  [updates]
  ...
  exclude=kernel-* qemu-*
  ...

  In /srv/yum/repos.d/updates.repo:
  [updates]
  ...
  exclude=any-package-name

Can some one comment on the expected behavior of using 'reposdir' to overlay
repository settings?  Is this supposed to work?  Is the 'updates' tag handled
differently?
Comment 7 Seth Vidal 2007-08-03 15:33:56 EDT
mulitiple repos with the same [name] are not allowed and the results will be
erratic, at best. this is a cantfix,

Note You need to log in before you can comment on or make changes to this bug.